#include "stdafx.h"
#include "converter.h"


CDXFtoX::CDXFtoX()
{
	m_d3drm			=NULL;
	m_meshbuilder	=NULL;

	m_reverse		=FALSE;
}

CDXFtoX::~CDXFtoX()
{
	if( m_meshbuilder )
	{
		m_meshbuilder->Release();
	}

	if( m_d3drm )
	{
		m_d3drm->Release();
	}
}



BOOL
CDXFtoX::Init(void)
{
	if( Direct3DRMCreate(&m_d3drm)!=D3DRM_OK )
	{
		return FALSE;
	}

	if( m_d3drm->CreateMeshBuilder(&m_meshbuilder)!=D3DRM_OK )
	{
		return FALSE;
	}

//	m_meshbuilder->ReserveSpace(10000,10000,10000);

	return TRUE;
}


void
CDXFtoX::SetReverse(BOOL tf)
{
	m_reverse=tf;
}


BOOL
CDXFtoX::Load(LPCTSTR filename)
{
	TCHAR	ext[1024];
	_tsplitpath(filename,NULL,NULL,NULL,ext);

	if( _tcsicmp(ext,".dxf")==0 )
	{
		return LoadDXF(filename);
	}

	return FALSE;
}


BOOL
CDXFtoX::LoadDXF(LPCTSTR filename)
{
	if( m_meshbuilder==NULL )
	{
		return FALSE;
	}


	FILE	*fp;
	TCHAR	str[1024];



	fp=fopen(filename,"rt");
	if( fp==NULL || (int)fp==-1 )
	{
		return FALSE;	// error
	}


	while( !feof(fp) )
	{
		// 3DFACE
		do {
			if( _fgetts(str,256,fp)==NULL )
			{
				goto load_end2;
			}
		} while( _tcsstr(str,"3DFACE")==NULL );


		// _~[
		fgets(str,256,fp);

		// _~[iʂ̖OHj
		fgets(str,256,fp);


		// face
		IDirect3DRMFace	*face;
		m_d3drm->CreateFace(&face);

		D3DVECTOR	vertex[256];
		long		edge_counter=0;

		while(TRUE)
		{
			long	dummy;
			float	x,y,z;

			// W̊Jn
	 		fscanf(fp," %ld \n",&dummy);
			if( (dummy/10)!=1 )
				break;

			fscanf(fp," %f \n",&x);

			// W̊Jn
	 		fscanf(fp," %ld \n",&dummy);
			fscanf(fp," %f \n",&y);

			// W̊Jn
	 		fscanf(fp," %ld \n",&dummy);
			fscanf(fp," %f \n",&z);

			// _L^Ă
			vertex[edge_counter].x=x;
			vertex[edge_counter].y=y;
			vertex[edge_counter].z=z;
			edge_counter++;
		}

		//@_o^
		if( m_reverse )
		{
			for(int i=0;i<edge_counter;i++)
			{
				face->AddVertex(vertex[i].x,vertex[i].y,vertex[i].z);
			}
		}
		else
		{
			for(int i=0;i<edge_counter;i++)
			{
				face->AddVertex(vertex[edge_counter-1-i].x,vertex[edge_counter-1-i].y,vertex[edge_counter-1-i].z);
			}
		}

		// MeshBuilderɖʂo^
		m_meshbuilder->AddFace( face );
	}

load_end2:

	fclose(fp);


	// @xNg𐶐
	m_meshbuilder->GenerateNormals();

	return TRUE;
}

BOOL
CDXFtoX::SaveX(LPCTSTR filename)
{
	if( m_meshbuilder==NULL )
	{
		return FALSE;
	}

	if( m_meshbuilder->Save(filename,D3DRMXOF_TEXT,D3DRMXOFSAVE_NORMALS)!=D3DRM_OK )
	{
		MessageBeep(MB_ICONEXCLAMATION);
		return FALSE;
	}

	return TRUE;
}
